<?php
	/* Get the PEAR stuff */
	require_once('DB.php');

	/* Include our stuff */
	include(".defs");
	include("${rootdir}/php/main.php");

	/* Start up */
	$db = db_connect();

	/* Auth */
	if($admin_auth_req==1)
	{ admin_auth(); }
?>
<?php print("<?xml version=\"1.0\" encoding=\"iso-8859-1\"?>\n")?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN"
	"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!-- $Fuller: myprograms/htbm/web/bmadmin.php,v 1.14 2002/07/21 13:39:33 fullermd Exp $ -->
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
<title>
Bookmark administration
</title>
<style type="text/css" media="all">
@import "bmark.css";
</style>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
</head>
<body>
<?php
	/* Figure out what mode we're in */
	if($commit)
	{
		/*
		 * We're in commit mode; enter the changes requested, print a
		 * success/error message, and slap up a link to wherever is
		 * appropriate.
		 */
		if($new==1 || $edit==1)
		{
			/* New and edit are ALMOST the same.  Share code. */
			/* Do some sanity checking */
			if(!$url)
			{
				print("<p>ERROR: Need URL specified!</p>\n");
				print("<p><a href=\"$self?new=1\">Enter new</a></p>\n");
				exit;
			}
			if(!$title)
			{
				print("<p>No title entered, using URL.");
				print("You may want to edit this bookmark and add a real title.");
				print("</p>\n");
				$title = $url;
			}
			$urlp = parse_url($url);
			if(strlen($urlp['scheme']) < 1)
			{
				print("<p>No URL scheme specified, assuming http://.");
				print("You should edit this bookmark if this isn't right.</p>\n");
				$url = "http://" . $url;
			}

			/* Escape info for safety */
			$cat_id = $db->quote($cat_id);
			$url = $db->quote($url);
			$title = $db->quote($title);
			$comment = $db->quote($comment);

			/* Start it */
			if($new==1)
			{
				$querystr = "INSERT INTO bookmarks "
						. "(cat_id,url,title,comment,created) "
						. "VALUES ($cat_id,$url,$title,$comment,"
						. "CURRENT_TIMESTAMP)";
			}
			else if($edit==1)
			{
				$querystr = "UPDATE bookmarks SET "
						. "cat_id=$cat_id, url=$url, title=$title, "
						. "comment=$comment "
						. "WHERE mark_id='$mark_id'";
			}
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* If we get here, success! */
			if($new==1)
			{ print("<p>New bookmark added!</p>\n"); }
			else if($edit==1)
			{ print("<p>Bookmark $mark_id changed!</p>\n"); }
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($dele==1)
		{
			/* Delete an entry */
			$querystr = "DELETE FROM bookmarks WHERE mark_id='$mark_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			print("<p>Ex-bookmark number $mark_id deleted!</p>\n");
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($catnew==1 || $catedit==1)
		{
			/* Again, new and edit are nearly identical */

			/* Escape for safety */
			$parent = $db->quote($parent);
			$name = $db->quote($name);

			/* Write edited category information */
			if($catnew==1)
			{
				$querystr = "INSERT INTO categories "
						. "(parent,name) "
						. "VALUES ($parent,$name)";
			} else {
				$querystr = "UPDATE categories SET "
						. "parent=$parent, name=$name "
						. "WHERE cat_id='$cat_id'";
			}
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			if($catnew==1)
			{ print("<p>New category added!</p>\n"); }
			else
			{ print("<p>Category info updated for category $cat_id.</p>\n"); }
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else if($catdele==1)
		{
			/*
			 * First, see if we CAN delete it.  If it has children, we'll
			 * just bail right now.  We need to add more flexibility
			 * here.
			 */
			$querystr = "SELECT COUNT(mark_id) FROM bookmarks "
					. "WHERE cat_id='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$temp = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$nbm = $temp[0];

			$querystr = "SELECT COUNT(cat_id) FROM categories "
					. "WHERE parent='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$temp = $result->fetchRow(DB_FETCHMODE_ORDERED);
			$nsc = $temp[0];

			/* See what we have, error out if necessary */
			if($nbm>0 || $nsc>0)
			{
				print("<h1>Error</h1>\n");
				print("<p>Category $cat_id has children ");
				print("($nsc categories, $nbm bookmarks) ");
				print("and thus can't be deleted.</p>\n");
				print("<p>\n");
				print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
				print("</p>\n");
				exit;
			}

			/* Delete an entry */
			$querystr = "DELETE FROM categories WHERE cat_id='$cat_id'";
			print("<!-- query is '$querystr' -->\n");
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }

			/* Success */
			print("<p>Ex-category number $cat_id deleted!</p>\n");
			print("<p>\n");
			print("<a href=\"bookmarks.php\">Back to bookmarks</a>\n");
			print("</p>\n");
		}
		else
		{
			/* XXX WRITEME XXX */
			exit;
		}
	}
	else
	{
		/* Regular modes */
		if($new==1)
		{
			/* New bookmark to create */
			?>
<h1 class="center">
Add new bookmark
</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			/* Create a form to enter a new bookmark */
			$bminfo = array();
			print_bmark_form($bminfo);
			?>
<div>
<input type="hidden" name="new" value="1" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($edit==1)
		{
			/* Edit existing bookmark */
			$querystr = "SELECT mark_id,cat_id,url,title,comment "
					. "FROM bookmarks WHERE mark_id='$mark_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			$bminfo = $result->fetchRow(DB_FETCHMODE_ASSOC);
			print("<form action=\"$self\" method=\"post\">\n");
			print_bmark_form($bminfo);
		?>
<div>
<input type="hidden" name="edit" value="1" />
<input type="hidden" name="mark_id" value="<?php echo("$mark_id")?>" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($dele==1)
		{
			/* Delete existing bookmark */
			$querystr = "SELECT mark_id,cat_id,url,title,comment "
					. "FROM bookmarks WHERE mark_id='$mark_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Bookmark ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			$bminfo = $result->fetchRow(DB_FETCHMODE_ASSOC);
		?>
<h1>CONFIRM DELETE</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			print_bmark_form($bminfo);
			?>
<div>
<input type="hidden" name="dele" value="1" />
<input type="hidden" name="mark_id" value="<?php echo("$mark_id")?>" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this bookmark?
</p>
<p>
<input type="submit" name="commit" value="Commit" />
</p>
</form>
<?php
		}
		else if($catedit==1)
		{
			/* Edit existing category */
			$querystr = "SELECT cat_id,parent,name "
					. "FROM categories WHERE cat_id='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Category ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			$catinfo = $result->fetchRow(DB_FETCHMODE_ASSOC);
			print("<form action=\"$self\" method=\"post\">\n");
			print_cat_form($catinfo);
		?>
<div>
<input type="hidden" name="catedit" value="1" />
<input type="hidden" name="cat_id" value="<?php echo("$cat_id")?>" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($catnew==1)
		{
			/* New category to create */
			?>
<h1 class="center">
Add new category
</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			/* Create a form to enter a new bookmark */
			$catinfo = array();
			print_cat_form($catinfo);
			?>
<div>
<input type="hidden" name="catnew" value="1" />
<input type="submit" name="commit" value="Commit" />
</div>
</form>
<?php
		}
		else if($catdele==1)
		{
			/* Delete existing bookmark */
			$querystr = "SELECT cat_id,parent,name "
					. "FROM categories WHERE cat_id='$cat_id'";
			$result = $db->query($querystr);
			if(DB::isError($result))
			{ die($result->getMessage()); }
			$nrows = $result->numRows();
			if($nrows == 0)
			{
				print("<p>Category ID not found!</p>\n");
				print("<p><a href=\"bookmarks.php\">Back to Bookmarks</a></p>\n");
				exit;
			}

			$catinfo = $result->fetchRow(DB_FETCHMODE_ASSOC);
		?>
<h1>CONFIRM DELETE</h1>
<form action="<?php echo("$self")?>" method="post">
<?php
			print_cat_form($catinfo);
			?>
<div>
<input type="hidden" name="catdele" value="1" />
<input type="hidden" name="cat_id" value="<?php echo("$cat_id")?>" />
</div>
<p>
Are you <em>SURE</em> you want to permamently delete this category?
</p>
<p>
<input type="submit" name="commit" value="Commit" />
</p>
</form>
<?php
		}

		/* Other stuff */
	}
		?>
<p class="center">
<a href="http://validator.w3.org/check/referer">
<img src="http://www.w3.org/Icons/valid-xhtml10"
  alt="Valid XHTML 1.0!" height="31" width="88" /></a>
<a href="http://jigsaw.w3.org/css-validator/check/referer">
<img style="border:0;width:88px;height:31px"
  src="http://jigsaw.w3.org/css-validator/images/vcss" alt="Valid CSS!" /></a>
</p>
</body>
</html>
